autostew/urls.py
from django.conf.urls import include, url
from django.contrib import admin

urlpatterns = [
    url(r'^accounts/', include('autostew_web_account.urls', namespace='account'), name='account'),
    url(r'^admin/', admin.site.urls, name='admin'),
    url(r'^api/', include('autostew_web_api.urls', namespace='api'), name='api'),
    url(r'^contact/', include('autostew_web_contact.urls', namespace='contact'), name='contact'),
    url(r'^session/', include('autostew_web_session.urls', namespace='session'), name='session'),
    url(r'^user/', include('autostew_web_users.urls', namespace='users'), name='user'),
    url(r'^', include('autostew_web_home.urls', namespace='home'), name='home'),
]

autostew_web_home/urls.py
from django.conf.urls import url
from django.views.generic.base import TemplateView, RedirectView

from autostew_web_home.views import HomeView

urlpatterns = [
    url(r'^favicon\.ico$', RedirectView.as_view(url='/static/autostew_web_home/img/Logo_RGB.png', permanent=True)),
    url(r'^faq$', TemplateView.as_view(template_name='autostew_web_home/faq.html'), name='faq'),
    url(r'^$', HomeView.as_view(), name='home'),
]

autostew_web_users/urls.py
from django.conf.urls import url
from django.views.generic.detail import DetailView
from django.views.generic.list import ListView

from autostew_web_users.models import SteamUser, SafetyClass
from autostew_web_users.views import SteamUserListView

app_name = 'users'
urlpatterns = [
    url(r'^list/?$', SteamUserListView.as_view(), name='list'),
    url(r'^safety_classes/?$', ListView.as_view(model=SafetyClass), name='safety_class_list'),
    url(r'^(?P<slug>.+)/?$', DetailView.as_view(model=SteamUser, slug_field='steam_id'), name='profile'),
]

autostew_web_home/views.py
from django.views.generic.base import TemplateView

from autostew_web_contact.models import ContactMessage
from autostew_web_session.models.server import Server


class HomeView(TemplateView):
    template_name = 'autostew_web_home/home.html'

    def get_context_data(self, **kwargs):
        context = super(HomeView, self).get_context_data(**kwargs)
        context['unread_messages'] = ContactMessage.objects.filter(read=False)
        context['unverified_servers'] = Server.objects.filter(back_verified=False)
        context['servers_in_race'] = [server for server in Server.objects.filter(current_session__isnull=False) if server.is_up]
        context['servers_online'] = [server for server in Server.objects.filter(current_session__isnull=True) if server.is_up]
        return context

autostew_web_home/templates/autostew_web_home/base.html
<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
        <title>Autostew</title>

        {% load staticfiles %}

        <!-- Bootstrap -->
        <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css"
                               integrity="sha384-1q8mTJOASx8j1Au+a5WDVnPi2lkFfwwEAa8hDDdjZlpLegxhjVME1fgjWPGmkzs7"
                               crossorigin="anonymous">
        <link rel="stylesheet" type="text/css" href="{% static 'autostew_web_home/css/bootstrap.min.css' %}" />


        <!-- custom stylings -->
        <link rel="stylesheet" type="text/css" href="{% static 'autostew_web_home/css/main.css' %}" />
        <link rel="stylesheet" type="text/css" href="{% static 'autostew_web_home/css/sticky-footer.css' %}" />
        <link rel="stylesheet" type="text/css" href="{% static 'autostew_web_home/css/weather-icons.min.css' %}" />

        <!-- HTML5 shim and Respond.js for IE8 support of HTML5 elements and media queries -->
        <!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
        <!--[if lt IE 9]>
            <script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
            <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
        <![endif]-->

        <script src="{% static 'autostew_web_home/js/sortable.min.js' %}"></script>
        <link rel="stylesheet" href="{% static 'autostew_web_home/css/sortable-theme-bootstrap.css' %}" />
    </head>
    <body class="body">
        <div class="container-fluid">
            <div class="row">
                <div class="col-md-3">
                    {% include "autostew_web_home/includes/navbar.html" %}
                </div>

                <div class="col-md-9">
                    <div class="container-fluid">
                        {% if messages %}
                                {% for message in messages %}
                                    <div class="alert alert-{{ message.tags }} alert-dismissible" role="alert">
                                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                                        {{ message }}
                                    </div>
                                {% endfor %}
                        {% endif %}
                        {% block content %}
                        {% endblock %}
                    </div>
                </div>
            </div>
        </div>

        {% include "autostew_web_home/includes/footer.html" %}

        <!-- jQuery (necessary for Bootstrap's JavaScript plugins) -->
        <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.3/jquery.min.js"></script>
        <!-- Include all compiled plugins (below), or include individual files as needed -->

        <!-- Latest compiled and minified JavaScript -->
        <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/js/bootstrap.min.js" 
                integrity="sha384-0mSbJDEHialfmuBBQP6A4Qrprq5OVfW37PRR3j5ELqxss1yVqOtnepnHVP9aJ7xS" 
                crossorigin="anonymous">
        </script>
    </body>
</html>

autostew_web_home/templates/autostew_web_home/faq.html
{% extends "autostew_web_home/base.html" %}

{% block content %}

    <h1 class="page-header">Help</h1>
    <h3>I am looking for a race I recently drove in but I can't find it</h3>
    <p>
        You can go to the <a href="{% url 'users:list' %}">user list</a>, look for your name there and see the list
        of races you recently participated in.
    </p>
    <hr>
    <h3>How are drivers rated?</h3>
    <p>
        Drivers have two independent ratings: the <b>safety class</b> and the <b>performance rating</b>.
    </p>
    <p>
        First and most important is the safety class. It describes how safe a driver is. The performance rating
        describes how much a driver wins or loses against other drivers.
    </p>
    <hr>
    <h3>How is the driver safety class calculated?</h3>
    <p>
        <a href="{% url 'users:safety_class_list' %}">See here a description of each safety class.</a>
    </p>
    <p>
        The Project CARS dedicated server reports impacts during the race, including the magnitude of them. Each time
        you have a collision, it's magnitude gets added to your safety rating, so a higher rating means a more unsafe
        driver. Collisions against the environment yield a maximum of 250 points, collisions against human drivers
        yield a maximum of 1.000 points. Collisions against AI drivers are not considered.
    </p>
    <p>
        For each clean lap you complete, your safety rating will improve. Complete many clean laps, and you will get
        a good safety rating.
    </p>
    <p>
        If a driver crashes excessively, she or he may be kicked from the game. That driver may rejoin immediately to
        the game if the event is still joinable (you will not be able to rejoin if the race is in progress). Eventually,
        an unsafe driver will reach the lowest safety class. Autostew will be strict with crashes by drivers in the
        lowest class until their behaviour improves.
    </p>
    <p>
        Crashes among human drivers will be weighted according to their safety class. Therefore if a driver with a bad
        rating crashes with a driver with a good rating, the well-rated driver will be automatically considered "less
        at fault" and will be awarded less crash points. The worse rated driver will always be awarded the full points
        count. A crash between two drivers of the same class will award both the full crash points.
    </p>
    <hr>
    <h3>Autostew logs crashes in a weird way!</h3>
    <p>
        Autostew cannot distinguish who is at fault in a crash. Also, as you will be playing online, it may happen that
        in your screen no crash happened, but the dedicated server still logs a crash. Even with its quirks, the system
        should in the long term assign good ratings to safe drivers and bad ratings to unsafe drivers.
    </p>
    <hr>
    <h3>I drive as safely as I can but I get kicked / have a low safety class anyway.</h3>
    <p>
        That means you are still crashing too much. We are fine-tuning the safety classes and crash limits, but one of
        our main goals is and will be to keep races clean.
    </p>
    <p>
        You can do several things to get less crash points. Be very careful at the start of the race, that is
        where most crashes happen. It is better to start the race cleanly and loose some positions in the first lap than
        ruining everybody's race (and many times your own too) being over-ambitious. You will have at least a few laps
        to get a good position. If you are unsure about an overtake, consider aborting it, especially in difficult
        corners.
    </p>
    <p>
        Be sure to respect racing rules. We will have some general rules posted soon.
    </p>
    <p>
        Some servers may have stricter crash limits than others. More info on this soon.
    </p>
    <p>
        If you can't control a car, try switching to a slower car class. It may seem boring at first, but it may be more
        rewarding to be able to concentrate on driving a car well instead of simply trying not trying to crash on every
        corner. There are generally less crashes in slower car classes. It may also be a good idea to mostly stick to
        one car class and learning only a few tracks at first. Consider joining a league just for the fun :)
    </p>
    <hr>
    <h3>How is the driver performance rating calculated?</h3>
    <p>
        We use the <a href="https://en.wikipedia.org/wiki/Elo_rating_system">Elo rating system</a>. You will be
        considered a winner over every driver who finished in a worse position than yours, but also over all drivers
        who completed a lap in any stage of the race but did not finish the race itself.
    </p>
    <p>
        In the Elo rating system, winners take points from losers. The beautiful thing about it is that the amount of
        points taken depends on the expected result of a game. Thus, if you lose against a driver who is much better
        than you, you will lose few points, but if you win against that same driver, you will get a lot of points from
        him. The same happens when you win or lose against drivers who are worse than you.
    </p>
    <p>
        The maximum points you can win from beating another driver is 5 per race (the "k" value). Therefore, if you win
        a race against 20 other players, you can get up to 100 points if all had a much better rating than you.
    </p>
{% endblock %}

autostew_web_home/templates/autostew_web_home/home.html
{% extends "autostew_web_home/base.html" %}

{% block content %}
    {% if user.is_authenticated and user.is_staff and unread_messages %}
        <div class="alert alert-info">
            There are {{ unread_messages|length }} unread messages.
        </div>
    {% endif %}
    {% if user.is_authenticated and user.is_staff and unverified_servers %}
        <div class="alert alert-success">
            There are {{ unverified_servers|length }} unverified servers.
        </div>
    {% endif %}

    <h1 class="page-header">Autostew <small>making online racing fun!</small></h1>

    <div class="row">
        <div class="col-xs-12 col-md-8 placeholder">
            <p>
                We think Project CARS is a really cool racing simulator. But we missed many features when playing online
                multiplayer. Luckily, the people at Slightly Mad Studios promotes development by the community. So Autostew came
                to be!
            </p>
            <p>
                <b>Autostew allows for a better on-line simulation experience.</b>
            </p>

            {% if servers_in_race %}
                <h2>Current events</h2>
                <div class="row">
                    {% for server in servers_in_race %}
                        <div class="col-xs-12 col-md-6 placeholder">
                            {% include 'autostew_web_session/server_badge.html' with server=server %}
                        </div>
                    {% endfor %}
                </div>
            {% endif %}

            {% if servers_online %}
                <h2>Idle servers</h2>
                <div class="row">
                    {% for server in servers_online %}
                        <div class="col-xs-12 col-md-6 placeholder">
                            {% include 'autostew_web_session/server_badge.html' with server=server %}
                        </div>
                    {% endfor %}
                </div>
            {% endif %}

            <h3>
                Features you can enjoy today!
            </h3>
            <ul>
                <li>Warns and kicks players who crash excessively.</li>
                <li>Rank players according to their safety record and their race performance.</li>
                <li>Announces the best laps and other important events during the race.</li>
                <li>Leaderboards with the fastest times.</li>
                <li>Saves race's results.</li>
                <li>Allows planning of races.</li>
                <li>Connect your own dedicated server to Autostew.</li>
                <li>Managing of dedicated server through the web interface.</li>
            </ul>

            <p>
                Want to know more? Look what we are
                <a href="https://waffle.io/Autostew/autostew">currently doing</a>
                and <a href="https://waffle.io/Autostew/autostew?label=help%20wanted">where we can use help</a>.
            </p>
        </div>
        <div class="col-xs-12 col-md-4 placeholder">
            <h3>Announcements</h3>
            <h4>DS admin zone now open <small>2016-04-26</small></h4>
            <p>
                <a href="{% url 'account:home' %}">Check it out here!</a> You are now able to add your DS there and also
                configure the setup queue and rotation.
            </p>
            <p>
                Mind that the DS settings page is still in development.
            </p>
            <hr>
            <h4>Performance &amp; new DSs <small>2016-04-25</small></h4>
            <p>
                We are having a lot of parallel races today, which is really good news! But we also experienced some
                performance issues due to that. We expanded our servers, so now everything should run smoother.
            </p>
            <p>
                To all those who want to connect your DSs to Autostew, please be patient as we are currently trying to
                keep up. Soon you will be able to add your DS over this website. Meanwhile consider registering in the
                <a href="{% url 'account:home' %}">DS admin zone</a>.
            </p>
            <hr>
            <h4>DS admin registration open! <small>2016-04-25</small></h4>
            <p>
                Autostew seems to be quite stable now. We also fixed a bug when the option "controlGameSetup" in the
                server.cfg was set to false. You may now set it to false to allow players to edit the session
                settings. Set it to true to make Autostew configure the races.
            </p>
            <p>
                If you are a DS admin and want to connect your DS to Autostew or already have a DS connected to
                Autostew, you may now register in the <a href="{% url 'account:home' %}">DS admin zone</a>. You will be
                soon able to manage your DS there. Stay tuned!
            </p>
            <hr>
            <h4>Major update <small>2016-04-19</small></h4>
            <p>
                We made a pretty large update! Most noticeable is the new logo (thanks Riccardo!), but we also made many
                changes under the hood that should make Autostew more stable and the source code easier to read and
                maintain. Please bear with us if there are some issues in the next days, you can also
                <a href="https://github.com/Autostew/autostew/issues/new">report the bugs you find</a>.
            </p>
            <p>
                PS: Don't worry, the previous ratings are still there, even if it doesn't show.
                To make it visible again, just complete a lap and you should be back where you were :)
            </p>
        </div>
    </div>
    <p>
        Send us <a href="{% url 'contact:contact' %}">your feedback</a>!
    </p>
{% endblock %}